// SPM.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "SPM.h"
#include <math.h>     //add
#include <algorithm>  //add
#include <queue>      //add for "JumpElim.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//
//	Note!
//
//		If this DLL is dynamically linked against the MFC
//		DLLs, any functions exported from this DLL which
//		call into MFC must have the AFX_MANAGE_STATE macro
//		added at the very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//

/////////////////////////////////////////////////////////////////////////////
// CSPMApp

BEGIN_MESSAGE_MAP(CSPMApp, CWinApp)
	//{{AFX_MSG_MAP(CSPMApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSPMApp construction

CSPMApp::CSPMApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CSPMApp object

CSPMApp theApp;


extern "C"
{

/////////////////////////////////////////////Extern C /////////////////////////////////////////////////////////////////	
	__declspec(dllexport) BOOL __stdcall GetVerSPMdll(float* Ver)
	{
	  *Ver = 1.02f;
	  return 1;
	}

	// 1 //*****************************
	// Open File
	//     *********************************
	// The structure of the SPM files header
	struct SPM_Header // User structure definition (SPM header)
	{
	 short tx;              // 2 byte Number of points in one step
	 short mx;              // 2 byte Matrix size on X direction
	 short ty;              // 2 byte Number of points in one step
	 short my;              // 2 byte Matrix size on Y direction
	 float kx;              // 4 byte X=mx*kx
	 float ky;              // 4 byte Y=my*ky
	 float Kz;              // 4 byte Z=matrix value * kz
	 char ZUnit [4];        // Label of z-axis
	 char XYUnit[4];        // Label of scanning plane
	 short sLenght;         // 2 byte String length
	 char Text[320];        // Notification string
	 char pole[98];         // Rest for reserve
	 char VERSION[64];      // Version of SPM "Nanotop"
	};                    // Total size 512 bytes

    __declspec(dllexport) BOOL __stdcall ReadSpmHeader(LPCTSTR filename, SPM_Header* OutDataHeader) 
	{
    SPM_Header DataHeader;

    CFile DataFile(filename, CFile::modeRead);
	//DataFile.Read((void *)&DataHeader,sizeof(DataHeader)); // OK!
    DataFile.Read(OutDataHeader,sizeof(DataHeader));
    DataFile.Close();    
    return 1;
	}

    __declspec(dllexport) BOOL __stdcall ReadSpmData(LPCTSTR filename, short CX, short CY, int* OutDataArray) 
	{
    short ReadData;

	LONG lOffset = 512, lActual;
    CFile DataFile(filename, CFile::modeRead);
	lActual = DataFile.Seek( lOffset, CFile::begin );   
    for (short y = 0; y < CY; y++)
	{
	  for (short x = 0; x < CX; x++)
	  {
		   DataFile.Read((void *)&ReadData, 2);
           OutDataArray[(x + (y * CX))] = (int)ReadData; 

	  }
	}
	DataFile.Close();
    return 1;
	}

    


	//Calc Max Min Parameter
	__declspec(dllexport) int __stdcall CalcMinMax2D(
	/*-Interface Information---------------------------------------------------------*/
	 unsigned int  sizeX,      /*  I   Number of complex data points.                */  
	 unsigned int  sizeY,      /*  I   Number of complex data points.                */ 
	 int* InArray,      /*  I   Input ReArray .                                      */
	 int* Fmin,         /*  0   Max .                                                */
	 int* Fmax)         /*  0   Min .                                                */
	/*-------------------------------------------------------------------------------*/
	{
	int tmpData;
	unsigned int x;
	unsigned int y;

	  *Fmax = -2147483646; // DEFINE MAX VALUE AS MINIMUM FOR INTEGER
	  *Fmin = 2147483647;  // DEFINE MIN VALUE AS MAXIMUM FOR INTEGER

	  for (y = 0; y < sizeY; y++)
	  {
		for (x = 0; x < sizeX; x++)
		{
		   tmpData = InArray[x + (y * sizeX)];  
		   if (tmpData > *Fmax) {*Fmax = tmpData;} //NEW MAX VALUE OF Z
		   if (tmpData < *Fmin) {*Fmin = tmpData;} //NEW MIN VALUE OF Z
		}
	  }
	return 0;
	}





    /////////////////////////////////////////////////////////////////////////////////////////////////////////
    //4 //*****************************
    // Whow Picture
    //*********************************
       extern "C" __declspec(dllexport) BOOL __stdcall DrawIntImage(HDC hDC_Pic, float Xscale, float Yscale,  int* InDataArray, short CX, short CY, int FMin, int FMax)
	{
    BYTE PicColor;
	COLORREF PixelColor;
    int dF;
	int CurrData;
	int X1;
	int X2;
	int Y1;
	int Y2;
    
    dF = FMax - FMin;

    for (short y = 0; y < CY-1; y++)
	{
	  for (short x = 0; x < CX-1; x++)
	  {
	    CurrData = InDataArray[(x + (y * CX))];
		if (CurrData < FMin ){CurrData = FMin;}
        if (CurrData > FMax ){CurrData = FMax;}
        PicColor = (BYTE)(0xFF * float(CurrData - FMin) / float(dF));
		PixelColor = RGB(PicColor,PicColor,PicColor);
        X1 = (int)(x*Xscale);
        X2 = (int)((x+1)*Xscale);
		Y1 = (int)(y*Yscale);
        Y2 = (int)((y+1)*Yscale);
		//========Draw Rect ===============
		for (int Py = Y1; Py < Y2; Py++)
		{
	      for (int Px = X1; Px < X2; Px++)
		  {
             SetPixel(hDC_Pic, Px, Py, PixelColor);
		  }
		}
        //=================================
	  }
	} 
    return 1;
	}


    
 /////////////////////////////////////////////End Extern C /////////////////////////////////////////////////////////////////
}